"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.astUtils = exports.utils = exports["default"] = void 0;

var types = _interopRequireWildcard(require("@babel/types"));

var utils = _interopRequireWildcard(require("./utils"));

exports.utils = utils;

var astUtils = _interopRequireWildcard(require("./utils/ast"));

exports.astUtils = astUtils;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var _default = function _default() {
  return {
    name: 'babel-plugin-jsx-sfc',
    visitor: {
      Program: function Program(_path, state) {
        _path.traverse({
          /*
            const App = sfc({
              Component: (props) => {
                ...
              },
                static: () => ({
                utils: { ... }
              }),
                render({ data }) {
                ...
              },
            
              styles: () => { ... }
            });
              ↓ ↓ ↓ ↓ ↓ ↓
              const $sfcOptions_lineNo = sfc.createOptions({
              static: () => ({
                utils: { ... }
              }),
                render({ data }) {
                ...
              },
          
              styles: () => ({
                ...
              })
            });
              const Sfc_lineNo = (props) => {
              ...
              return $sfcOptions_lineNo.render({ ... });
            };
              const App = sfc(Sfc_lineNo, $sfcOptions_lineNo);
          */
          CallExpression: {
            enter: function enter(path) {
              var _state$opts;

              var callee = path.node.callee;
              var importedLib = state === null || state === void 0 ? void 0 : (_state$opts = state.opts) === null || _state$opts === void 0 ? void 0 : _state$opts.importedLib;
              /**
               * 0: nothing
               * 1: const App = sfc()({ ... })
               * 2: const App = sfc({ ... })
               * 3: const App = sfc.forwardRef()({ ... })
               * 4: const App = sfc.forwardRef({ ... })
               */

              var sfcType = 0;

              if (types.isCallExpression(callee) && astUtils.isCalleeImportedBySfc(callee.callee, path, importedLib, state === null || state === void 0 ? void 0 : state.customImportName)) {
                if (types.isMemberExpression(callee.callee) && types.isIdentifier(callee.callee.property) && callee.callee.property.name === utils.SFC_FORWARD_REF) {
                  sfcType = 3;
                } else {
                  sfcType = 1;
                }
              } else if (astUtils.isCalleeImportedBySfc(callee, path, importedLib, state === null || state === void 0 ? void 0 : state.customImportName)) {
                if (types.isMemberExpression(callee) && types.isIdentifier(callee.property) && callee.property.name === utils.SFC_FORWARD_REF) {
                  sfcType = 4;
                } else {
                  sfcType = 2;
                }
              }

              if (sfcType) {
                var sfcArguments = path.node.arguments;

                if (types.isObjectExpression(sfcArguments === null || sfcArguments === void 0 ? void 0 : sfcArguments[0])) {
                  var _path$node, _path$node$loc, _state$customImportNa;

                  var componentProp = sfcArguments[0].properties.find(function (prop) {
                    return types.isObjectProperty(prop) && types.isIdentifier(prop.key) && prop.key.name === utils.SFC_COMPONENT;
                  });
                  var componentMethod = sfcArguments[0].properties.find(function (prop) {
                    return types.isObjectMethod(prop) && types.isIdentifier(prop.key) && prop.key.name === utils.SFC_COMPONENT;
                  });

                  if (!componentProp && !componentMethod) {
                    return;
                  }

                  var indexInProps = sfcArguments[0].properties.indexOf(componentProp ? componentProp : componentMethod);
                  var lineNo = path === null || path === void 0 ? void 0 : (_path$node = path.node) === null || _path$node === void 0 ? void 0 : (_path$node$loc = _path$node.loc) === null || _path$node$loc === void 0 ? void 0 : _path$node$loc.start.line;
                  var sfcOptionsName = (0, utils.getOptionsName)(lineNo);
                  /*
                    Component: props => {
                      return { firstName: 'joe' };
                    }
                      ↓ ↓ ↓ ↓ ↓ ↓ 
                      Component: props => {
                      return $sfcOptions_lineNo.render({ firstName: 'joe' });
                    }
                  */

                  var componentFuncPath;

                  if (componentProp) {
                    componentFuncPath = path.get("arguments.0.properties.".concat(indexInProps, ".value"));
                  } else {
                    componentFuncPath = path.get("arguments.0.properties.".concat(indexInProps));
                  }

                  var funcBlockPath = componentFuncPath.get('body');
                  var firstPropParamPath = componentFuncPath.get('params.0');
                  var propsName = '__props';

                  if (firstPropParamPath) {
                    if (types.isObjectPattern(firstPropParamPath.node)) {
                      // const { styles, props } = { ...__props, ...$sfcOptions_lineNo, props: __props, originalProps(deprecated): __props };
                      funcBlockPath.unshiftContainer('body', types.variableDeclaration('const', [types.variableDeclarator(firstPropParamPath.node, types.objectExpression([types.spreadElement(types.identifier(propsName)), types.spreadElement(types.identifier(sfcOptionsName)), types.objectProperty(types.identifier('props'), types.identifier(propsName)), types.objectProperty(types.identifier('originalProps'), types.identifier(propsName))]))]));
                      firstPropParamPath.replaceWith(types.identifier(propsName));
                    } else {
                      // props = { ...props, ...$sfcOptions_lineNo };
                      propsName = firstPropParamPath.node.name;
                      funcBlockPath.unshiftContainer('body', types.expressionStatement(types.assignmentExpression('=', types.identifier(propsName), types.objectExpression([types.spreadElement(types.identifier(propsName)), types.spreadElement(types.identifier(sfcOptionsName))]))));
                    }
                  } else {
                    if (types.isObjectMethod(componentFuncPath.node)) {
                      componentFuncPath.replaceWith(types.objectMethod('method', types.identifier(utils.SFC_COMPONENT), [types.identifier(propsName)], funcBlockPath.node));
                    } else {
                      componentFuncPath.replaceWith(types.arrowFunctionExpression([types.identifier(propsName)], funcBlockPath.node));
                    }
                  }

                  var returnArgPath = componentFuncPath.get('body.body').find(function (p) {
                    return p.isReturnStatement();
                  }); // return $sfcOptions_lineNo.render({ ... });

                  var existProps = null;

                  if (types.isObjectExpression(returnArgPath.node.argument)) {
                    returnArgPath.replaceWith(types.returnStatement(types.callExpression(types.memberExpression(types.identifier(sfcOptionsName), types.identifier(utils.SFC_RENDER)), [types.objectExpression([].concat(_toConsumableArray(returnArgPath.node.argument.properties.filter(function (property) {
                      if (types.isObjectProperty(property) && types.isIdentifier(property.key) && property.key.name === 'props') {
                        existProps = property;
                        return false;
                      }

                      return true;
                    })), [existProps || types.objectProperty(types.identifier('props'), types.identifier(propsName))]))])));
                  }

                  sfcArguments[0].properties.splice(indexInProps, 1); // const $sfcOptions_lineNo = ...

                  var componentVariable = path.findParent(function (path) {
                    return path.isVariableDeclaration() || path.isExportDefaultDeclaration();
                  });
                  var importName = (state === null || state === void 0 ? void 0 : (_state$customImportNa = state.customImportName) === null || _state$customImportNa === void 0 ? void 0 : _state$customImportNa.name) || utils.SFC_FUNC;
                  var sfcOptionsPath = componentVariable === null || componentVariable === void 0 ? void 0 : componentVariable.insertBefore(types.variableDeclaration('const', [types.variableDeclarator(types.identifier(sfcOptionsName), types.callExpression(types.memberExpression(types.identifier(importName), types.identifier(utils.SFC_CREATE_OPTIONS)), sfcArguments))]));
                  var actualComponentFunc;

                  if (types.isArrowFunctionExpression(componentFuncPath.node)) {
                    actualComponentFunc = componentFuncPath.node;
                  } else {
                    actualComponentFunc = types.arrowFunctionExpression(componentFuncPath.node.params, componentFuncPath.node.body);
                  }

                  if (sfcType <= 2) {
                    var sfcName = (0, utils.getSfcName)(lineNo);
                    componentVariable === null || componentVariable === void 0 ? void 0 : componentVariable.insertBefore(types.variableDeclaration('const', [types.variableDeclarator(types.identifier(sfcName), actualComponentFunc)]));

                    if (types.isVariableDeclaration(componentVariable === null || componentVariable === void 0 ? void 0 : componentVariable.node)) {
                      var _componentVariable$no, _componentVariable$no2;

                      var declarationId = componentVariable === null || componentVariable === void 0 ? void 0 : (_componentVariable$no = componentVariable.node.declarations) === null || _componentVariable$no === void 0 ? void 0 : (_componentVariable$no2 = _componentVariable$no[0]) === null || _componentVariable$no2 === void 0 ? void 0 : _componentVariable$no2.id;

                      if (types.isIdentifier(declarationId)) {
                        var componentName = declarationId.name;
                        componentVariable === null || componentVariable === void 0 ? void 0 : componentVariable.insertBefore(types.expressionStatement(types.assignmentExpression('=', types.memberExpression(types.identifier(sfcName), types.identifier('displayName')), types.stringLiteral(componentName))));
                      }
                    }

                    path.replaceWith(types.callExpression(types.identifier(importName), [types.identifier(sfcName), types.identifier(sfcOptionsName)]));
                  } else {
                    path.replaceWith(types.callExpression(types.memberExpression(types.identifier(importName), types.identifier(utils.SFC_FORWARD_REF)), [actualComponentFunc, types.identifier(sfcOptionsName)]));
                  }
                  /* You can use @babel/generator here when debugging */
                  // console.log(generate(path.node).code);
                  // console.log(generate(sfcOptionsPath[0].node).code);

                }
              }
            }
          }
        });
      }
    }
  };
};

exports["default"] = _default;